/* See LICENSE of license details. */

#include "platform.h"
#include <errno.h>
#include <stdint.h>
#include <sys/types.h>
#include <unistd.h>

ssize_t _bsp_write(int fd, const void *ptr, size_t len) {
  const uint8_t *current = (const uint8_t *)ptr;
  if (isatty(fd)) {
    for (size_t jj = 0; jj < len; jj++) {
      uart_write(uart, current[jj]);
      if (current[jj] == '\n') {
        uart_write(uart, '\r');
      }
    }
    return len;
  }
  return 1;
}
