/* See LICENSE of license details. */

#include "stub.h"
#include "weak_under_alias.h"
#include <errno.h>
#if defined(SEMIHOSTING)
#include "semihosting.h"
#endif

int __wrap_unlink(const char *name) {
#if defined(SEMIHOSTING)
  return sh_remove(name);
#endif
  return _stub(ENOENT);
}
weak_under_alias(unlink);
